/*$Header: fcopyn.cv  1.1  92/12/20 21:50:40  MIURA  Exp $

	long fcopyn(FILE *from, FILE *to, long length)
	long fcopynb(FILE *from, FILE *to, long length)
	
	ȥ꡼फ饹ȥ꡼ػĹԡ
	顼ʤХԡǤХȿ֤
	顼-1L֤
	fcopynbϥХåեݤʤ
	
	FILE *from	ԡΥȥ꡼
	FILE *to	ԡΥȥ꡼
	long length	ԡĹ

	by Miurasoft
*/

#include <stdio.h>
#include <stdlib.h>

#ifndef FCOPY_BUFSIZE
#define FCOPY_BUFSIZE 16384
#endif
#ifndef FCOPY_BUFDIV
#define FCOPY_BUFDIV 1
#endif

#define BUF_SIZ (FCOPY_BUFSIZE)
#define REC_SIZ (FCOPY_BUFSIZE/FCOPY_BUFDIV)
#define REC_NUM (FCOPY_BUFDIV)

long fcopynb(FILE *from, FILE *to, long length)
{
	int c;
	long left;
	
	for (left=length; left>0 && (c=fgetc(from))!=EOF; --left)
		if (fputc(c, to)==EOF)
			goto error;
	
	return length-left;

error:
	return -1L;
}

long fcopyn(FILE *from, FILE *to, long length)
{
	long left, copied, lc;
	long now;
	char *buf;
	int r;
	
	copied=0L;
#ifndef FCOPY_NOBUF
	if ((buf=(char *)malloc(BUF_SIZ))!=NULL) {
		for(left=length; left>=BUF_SIZ; left-=BUF_SIZ) {
			if (fseek(from, 0, SEEK_CUR))
				goto error;
			if (fseek(to, 0, SEEK_CUR))
				goto error;
			if ((now=ftell(from))==-1L)
				goto error;
			if ((r=fread(buf, REC_SIZ, REC_NUM, from))==REC_NUM) {
				if (fwrite(buf, REC_SIZ, REC_NUM, to)<REC_NUM)
					goto error;
				copied+=BUF_SIZ;
			} else {
				if (fseek(from, now, SEEK_SET))
					goto error;
				if (r>0) {
					if (fwrite(buf, REC_SIZ, r, to)<r)
						goto error;
					if (fseek(from, now+r*REC_SIZ, SEEK_SET))
						goto error;
					copied+=r*REC_SIZ;
					left-=r*REC_SIZ;
				}
				break;
			}
		}
		/* Here, left is less than BUF_SIZ and in 'int' range. */
		if (fseek(from, 0, SEEK_CUR))
			goto error;
		if (fseek(to, 0, SEEK_CUR))
			goto error;
		if ((now=ftell(from))==-1L)
			goto error;
		if (left>0) {
			if (fread(buf, (int)left, 1, from)==1) {
				if (fwrite(buf, (int)left, 1, to)<1)
					goto error;
				copied+=left;
			} else {
				if (fseek(from, now, SEEK_SET))
					goto error;
				if ((lc=fcopynb(from, to, left))==-1L)
					goto error;
				copied+=lc;
			}
		}
		free(buf);
	} else {
#endif
		if ((copied=fcopynb(from, to, length))<0L)
			goto errornb;
#ifndef FCOPY_NOBUF
	}
#endif
	return copied;

error:
#ifndef FCOPY_NOBUF
	free(buf);
#endif
errornb:
	return -1L;
}

#ifdef TEST
int main(int argc, char *argv[])
{
	long l, lc;
	FILE *fi, *fo;
	
	if (argc!=4) {
		puts("usage: fcopyn <from> <to> <length>");
		exit(0);
	}
	if ((l=atol(argv[3]))<=0L)
		goto error;
#ifdef __MSDOS__
	if ((fi=fopen(argv[1],"rb"))==NULL)
		goto error;
	if ((fo=fopen(argv[2],"wb"))==NULL) {
		fclose(fi);
		goto error;
	}
#else
	if ((fi=fopen(argv[1],"r"))==NULL)
		goto error;
	if ((fo=fopen(argv[2],"w"))==NULL) {
		fclose(fi);
		goto error;
	}
#endif
	lc=fcopyn(fi, fo, l);
	fclose(fo);
	fclose(fi);
	printf("%ld bytes (all=%ld) copied.\n", lc, l);
	
	return 0;

error:
	printf("error occurred.\n");
	return 1;
}
#endif

