/*$Header: slice.cv  1.3  92/12/20 22:58:58  MIURA  Exp $

	slice.c
	
	礭ʥեʣʬ䤹

	ǡ slice -# infile

	by Miurasoft

*/

#include <stdio.h>
#include <stdlib.h>
#ifdef __MSDOS__
#include <dir.h>
#endif

#include "fcopyn.h"

#define YES 1
#define NO  0

int main(int argc, char *argv[]);
int fslice(char *infile, char *outfile, long siz);

#ifdef __TURBOC__
unsigned _stklen=8192;
#endif

char msg_ident[]=	"$Header: slice.cv  1.3  92/12/20 22:58:58  MIURA  Exp $";
char msg_fewpar[]=	"too few parameters\n";
char msg_manypar[]=	"too many parameters\n";
char msg_unkopt[]=	"unknown option '%s'\n";
char msg_nofile[]=	"no such file '%s'\n";
char msg_cantopen[]="cannot open file '%s'\n";
char msg_dskful[]=	"disk full\n";
char msg_toobig[]=	"file too big '%s'\n";
char msg_usage[]=	"usage: slice -# infile [outfile]\n           #: size of each slice\n";
			/*unixsplitΥХʥ*/
/*λ
	"usage: slice {-#x#[o<name>]}* [infile]\n"
	"options: #x#     size, number of files\n"
	"                 x: x|b   - byte (binary-mode)\n"
	"                    c|w|l - char|word|line (ascii-mode)\n"
	"         o<name> name header to output\n"
	"                 '#' as 001-999\n"
	"                 '~' as aa-zz\n";
*/

int main(int argc, char *argv[])
{
	long siz;
	char *outfile;
	
	if (argc==1) {
		puts(msg_usage);
		return 0;
	}
	if (argc==2) {
		fprintf(stderr, msg_fewpar);
		return 1;
	}
	if (argc>4) {
		fprintf(stderr, msg_manypar);
		return 1;
	}
	if (argv[1][0]!='-') {
		fprintf(stderr, msg_unkopt, argv[1]);
		return 1;
	}
	
	if ((siz=atol(&argv[1][1]))<=0) {
		fprintf(stderr, msg_unkopt, argv[1]);
		return 1;
	}
	
	if (argc==3) 
		outfile=argv[2];
	else
		outfile=argv[3];
	
	return fslice(argv[2], outfile, siz);
}

int fslice(char *infile, char *outfile, long siz)
{
#ifdef __MSDOS__
	char snum[MAXEXT];
	char drive[MAXDRIVE];
	char dir[MAXDIR];
	char file[MAXFILE];
	char ext[MAXEXT];
	char dst[MAXPATH];
#else
	char dst[256];
#endif
	int nfile;
	FILE *fi, *fo;
	long r;
	
	if ((fi=fopen(infile, "rb"))==NULL) {
		fprintf(stderr, msg_nofile, infile);
		return 1;
	}
#ifdef __MSDOS__
	fnsplit(outfile, drive, dir, file, ext);
#endif
	nfile=1;
	do {
#ifdef __MSDOS__
		sprintf(snum, ".%03d", nfile);
		fnmerge(dst, drive, dir, file, snum);
#else
		sprintf(dst, "%s.%03d", outfile, nfile);
#endif
		if ((fo=fopen(dst, "wb"))==NULL) {
			fclose(fi);
			fprintf(stderr, msg_cantopen, dst);
			return 1;
		}
		if ((r=fcopyn(fi, fo, siz))<0L) {
			fclose(fi);
			fclose(fo);
			fprintf(stderr, msg_dskful);
			return 1;
		}
		fclose(fo);
	} while (r==siz && ++nfile<1000);
	if (nfile>=1000 && fgetc(fi)!=EOF) {
		fprintf(stderr, msg_toobig, outfile);
		fclose(fi);
		return 1;
	}
	fclose(fi);
	return 0;
}

